searchData={"items":[{"type":"module","title":"Lissome","doc":"Integration of Gleam's Lustre framework with Phoenix LiveView","ref":"Lissome.html"},{"type":"module","title":"Lissome.Component","doc":"","ref":"Lissome.Component.html"},{"type":"function","title":"Lissome.Component.lustre/1","doc":"Renders a lustre app.","ref":"Lissome.Component.html#lustre/1"},{"type":"function","title":"Attributes - Lissome.Component.lustre/1","doc":"* `name` (`:atom`) (required) - The name of the Gleam module to render relative to the src directory.Examples include `:my_lustre_app`, and `:pages@home`.\n* `flags` (`:map`) - Initial values to pass to the Gleam module. Defaults to `%{}`.\n* `init_fn` (`:atom`) - The name of your Gleam function that initializes the model. Defaults to `:init`.\n* `view_fn` (`:atom`) - The name of your Gleam function that renders the view. Defaults to `:view`.\n* `flags_type` (`:atom`) - The name of your Gleam type that represents the flags your init function receives. Defaults to `:model`.\n* `id` (`:string`) - The id Lustre targets to render into. Defaults to `\"app\"`.\n* `class` (`:string`) - The class name to apply to the rendered app. Defaults to `\"\"`.\n* `ssr` (`:boolean`) - Whether to render the app on the server side. Defaults to `false`.","ref":"Lissome.Component.html#lustre/1-attributes"},{"type":"module","title":"Lissome.GleamBuilder","doc":"Wrapper around the Gleam build tool.\n\nThis module provides functionality to build Gleam source files to either JavaScript or Erlang targets using the Gleam CLI.","ref":"Lissome.GleamBuilder.html"},{"type":"function","title":"Lissome.GleamBuilder.build_gleam/2","doc":"Builds Gleam source files to the specified target using the `gleam build` command.\n\nThe target can be `:javascript`, `:erlang`, or a list of both.\n\nReturns `:ok`.","ref":"Lissome.GleamBuilder.html#build_gleam/2"},{"type":"function","title":"Options - Lissome.GleamBuilder.build_gleam/2","doc":"* `:gleam_dir` - Path to the Gleam project. Defaults to the `:gleam_dir` config in `lissome`, or `\"assets/lustre_app\"` if not set.\n  * `:compile_package` - If `true`, uses `gleam compile-package` instead of `gleam build` (default: `false`).\n  * `:watch` - If `true`, watches for file changes and rebuilds automatically. Requires the `FileSystem` package to be available (default: `false`).\n  * `:load_beam_modules` - If `true` and the target is `:erlang`, loads compiled modules automatically (default: `true`).\n  * `:erlang_outdir` - Custom output directory for Erlang beam files (only used with the `:erlang` target). Defaults to `\"{build_path}/lib/_{gleam_app}/\"`, where `gleam_app` is the name from `gleam.toml`.","ref":"Lissome.GleamBuilder.html#build_gleam/2-options"},{"type":"function","title":"Examples - Lissome.GleamBuilder.build_gleam/2","doc":"iex> Lissome.GleamBuilder.build_gleam(:erlang)\n\n    iex> Lissome.GleamBuilder.build_gleam([:javascript, :erlang])\n\n    iex> Lissome.GleamBuilder.build_gleam(:javascript,\n    ...>   gleam_dir: \"assets/my_gleam_app\",\n    ...>   compile_package: true,\n    ...>   watch: true\n    ...> )","ref":"Lissome.GleamBuilder.html#build_gleam/2-examples"},{"type":"macro","title":"Lissome.GleamBuilder.is_valid_target/1","doc":"","ref":"Lissome.GleamBuilder.html#is_valid_target/1"},{"type":"module","title":"Lissome.GleamReloader","doc":"A `GenServer` to watch for changes to Gleam files and recompile them.\n\nThis module requires the `FileSystem` package, which is not included with Lissome. In typical Phoenix projects, `FileSystem` is already available in the `:dev` environment through `phoenix_live_reload`.","ref":"Lissome.GleamReloader.html"},{"type":"function","title":"Lissome.GleamReloader.handle_info/2","doc":"","ref":"Lissome.GleamReloader.html#handle_info/2"},{"type":"function","title":"Lissome.GleamReloader.init/1","doc":"","ref":"Lissome.GleamReloader.html#init/1"},{"type":"function","title":"Lissome.GleamReloader.register_target/2","doc":"Registers a new target for the Gleam reloader to watch and compile.\n\nThis function starts a new reloader GenServer if one doesn't exist, or adds the target to an existing GenServer.","ref":"Lissome.GleamReloader.html#register_target/2"},{"type":"function","title":"Lissome.GleamReloader.start_link/1","doc":"Starts the Gleam reloader GenServer.","ref":"Lissome.GleamReloader.html#start_link/1"},{"type":"module","title":"Lissome.GleamType","doc":"Helpers to work with Gleam types and their Erlang representations.","ref":"Lissome.GleamType.html"},{"type":"function","title":"Lissome.GleamType.flat_tuple_map/1","doc":"Flattens a nested GleamType record structure into a single map.\n\nRecursively traverses the values and merges nested GleamTypes into a single flat map. This is intended to convert a GleamType struct into a map that can be serialized to JSON.","ref":"Lissome.GleamType.html#flat_tuple_map/1"},{"type":"function","title":"Examples - Lissome.GleamType.flat_tuple_map/1","doc":"iex> flat_tuple_map(%{name: {0, \"John\"}, address: {1, %GleamType{name: :address, values: %{city: {0, \"NY\"}}}}})\n    %{name: \"John\", city: \"NY\"}","ref":"Lissome.GleamType.html#flat_tuple_map/1-examples"},{"type":"function","title":"Lissome.GleamType.from_record/4","doc":"Creates a GleamType from a Gleam record.\n\nExtracts record information from the corresponding .hrl file and builds a GleamType with the proper structure. Each field is stored with the index where that field should be in the Erlang tuple.","ref":"Lissome.GleamType.html#from_record/4"},{"type":"function","title":"Options - Lissome.GleamType.from_record/4","doc":"* `:hrl_file_path` - Path to the .hrl file where the record is defined.Defaults to `{gleam_dir}/build/dev/erlang/{gleam_app}/{module}_{capitalized_type}.hrl`, where:\n    - `gleam_dir` is  the value of `:gleam_dir` config in `lissome`, or `\"assets/lustre_app\"` if not set\n    - `gleam_app` is the `:gleam_app` option or its default value if not provided.\n    - `capitalized_type` is the name of the type but with its first character in uppercase.\n  * `:gleam_app` - Name of the Gleam application Defaults to the value of `:gleam_app` config in `lissome`, or `\"lustre_app\"` if not set","ref":"Lissome.GleamType.html#from_record/4-options"},{"type":"function","title":"Examples - Lissome.GleamType.from_record/4","doc":"iex> from_record(:person, :my_gleam_module, %{name: \"John\", age: 30})\n    %GleamType{name: :person, values: %{name: {0, \"John\"}, age: {1, 30}, __gleam_record__: true}}","ref":"Lissome.GleamType.html#from_record/4-examples"},{"type":"function","title":"Lissome.GleamType.from_value/2","doc":"Creates a new GleamType from a type name and value.\n\nThis function only wraps the value in a tuple with the type name.\nFor cases where the type has multiple fields, use `from_record/4` instead.","ref":"Lissome.GleamType.html#from_value/2"},{"type":"function","title":"Examples - Lissome.GleamType.from_value/2","doc":"iex> from_value(:some, \"hello\")\n    %GleamType{name: :some, values: \"hello\"}\n\n    iex> from_value(:error, \"something went wrong\")\n    %GleamType{name: :error, values: \"something went wrong\"}","ref":"Lissome.GleamType.html#from_value/2-examples"},{"type":"function","title":"Lissome.GleamType.gleam_type?/1","doc":"Checks if a value is a GleamType struct.","ref":"Lissome.GleamType.html#gleam_type?/1"},{"type":"function","title":"Examples - Lissome.GleamType.gleam_type?/1","doc":"iex> gleam_type?(%Lissome.GleamType{})\n    true\n\n    iex> gleam_type?(\"not a gleam type\")\n    false","ref":"Lissome.GleamType.html#gleam_type?/1-examples"},{"type":"type","title":"Lissome.GleamType.t/0","doc":"The GleamType struct type.","ref":"Lissome.GleamType.html#t:t/0"},{"type":"function","title":"Lissome.GleamType.to_erlang_tuple/1","doc":"Converts a GleamType struct to its corresponding Erlang tuple.\n\nHandles nested GleamTypes structs inside the values, converting them to their Erlang tuples as well.\n\nIf the GleamType was constructed using a record, then this functions\nguarantees that the tuple will have the values in the order Erlang expects them.","ref":"Lissome.GleamType.html#to_erlang_tuple/1"},{"type":"function","title":"Examples - Lissome.GleamType.to_erlang_tuple/1","doc":"iex> to_erlang_tuple(%GleamType{name: :point, values: %{x: {0, 1}, y: {1, 2}}})\n    {:point, 1, 2}\n\n    iex> to_erlang_tuple(%GleamType{name: :person, values: %{name: {0, \"John\"}, skill: {1, %GleamType{name: :skill, values: %{name: {0, \"coding\"}, proficiency: {1, 10}}}}}})\n    {:person, \"John\", {:skill, \"coding\", 10}}","ref":"Lissome.GleamType.html#to_erlang_tuple/1-examples"},{"type":"module","title":"Lissome.Render","doc":"","ref":"Lissome.Render.html"},{"type":"function","title":"Lissome.Render.render_lustre/3","doc":"Renders a lustre app in client side.\n\nThis function just renders the root container and the script tags necessary to mount the app.","ref":"Lissome.Render.html#render_lustre/3"},{"type":"function","title":"Lissome.Render.ssr_lustre/3","doc":"Renders a lustre app in server side.\n\nThis function will call the `init_fn` function to get the initial model and then the `view_fn` function to get the initial view.","ref":"Lissome.Render.html#ssr_lustre/3"},{"type":"module","title":"Lissome.Utils","doc":"","ref":"Lissome.Utils.html"},{"type":"function","title":"Lissome.Utils.extract_gleam_app_name/1","doc":"","ref":"Lissome.Utils.html#extract_gleam_app_name/1"},{"type":"function","title":"Lissome.Utils.gleam_app/0","doc":"Returns the configured Gleam app name (default: lustre_app)","ref":"Lissome.Utils.html#gleam_app/0"},{"type":"function","title":"Lissome.Utils.gleam_dir_path/0","doc":"Returns the configured Gleam directory path (default: assets/lustre_app)","ref":"Lissome.Utils.html#gleam_dir_path/0"},{"type":"function","title":"Lissome.Utils.json/1","doc":"","ref":"Lissome.Utils.html#json/1"},{"type":"task","title":"mix compile.gleam","doc":"Compiles Gleam source files BEAM files.\n\nThis task compiles your Gleam source files in two steps:\n  1. First, it uses `gleam build` command to convert Gleam files into Erlang (`.erl`) files\n  2. Then it compiles those Erlang files into BEAM bytecode using Erlang's `:code` module\n\nThe resulting BEAM files are placed in your project's build directory under the directory matching your application name.\n\nInclude this task in your project's `mix.exs` with, e.g.:\n\n    def project do\n      [\n        compilers: Mix.compilers() ++ [:gleam],\n      ]\n    end\n\nFor other ways to compile Gleam code, see `Mix.Tasks.Lissome.BuildGleam`.","ref":"Mix.Tasks.Compile.Gleam.html"},{"type":"task","title":"mix lissome.build_gleam","doc":"Builds Gleam source files to either JavaScript or Erlang targets using the `gleam build` command.\n\nThe gleam directory could be specified as an argument. If it is not provided, the path under `:gleam_dir` in the configuration is used with a fallback in case the configuration is not set. See `Lissome.GleamBuilder.build_gleam/1` for more details.\n\nThe default target is Erlang.","ref":"Mix.Tasks.Lissome.BuildGleam.html"},{"type":"task","title":"Usage: - mix lissome.build_gleam","doc":"mix lissome.build_gleam\n  mix lissome.build_gleam --target [javascript | erlang]\n  mix lissome.build_gleam \"path/to/my_gleam_dir\" --target [javascript | erlang]","ref":"Mix.Tasks.Lissome.BuildGleam.html#module-usage"},{"type":"extras","title":"Lissome","doc":"# Lissome\n\nLissome is a library to integrate the [Gleam](https://gleam.run/) frontend framework [Lustre](https://hexdocs.pm/lustre/lustre.html) with Phoenix Live View.\n\n> [!WARNING]\n> This project is on early stage of development and breaking changes are expected.","ref":"readme.html"},{"type":"extras","title":"Setup - Lissome","doc":"First, make sure you have the Gleam compiler installed. Instructions can be found [here](https://gleam.run/getting-started/installing/)\n\n1. Add `lissome` and `lustre` to your `mix.exs` file:\n\n```elixir\ndef deps do\n  [\n    ...,\n    {:lissome, \"~> 0.3.1\"},\n    {:lustre, \"~> 4.6.3\", app: false, manager: :rebar3}\n  ]\nend\n```\n\nthen run:\n\n```bash\nmix deps.get\n```\n\n2. Create a new Gleam project and add Lustre to it. You can create it anywhere, but it is recommended to create it inside the `assets` directory. By default, Lissome will search for a Gleam project in the `assets/lustre_app` directory. If you chose a different name, set the path where you Gleam project lives in the `gleam_dir` config:\n\n```bash\ngleam new my_gleam_app\n\ncd my_gleam_app\ngleam add lustre\n```\n\n```elixir\n# config/config.exs\n\n# if you created your Gleam project in a different location than \"assets/lustre_app\"\nconfig :lissome, :gleam_dir: \"my_dir/my_gleam_app\"\n```\n\nLissome ships with its own gleam package that contains utilities functions to interop with Phoenix LiveView. You can add it to your Gleam project as a path dependency:\n\n```toml\n# gleam.toml\n\n[dependencies]\nlissome = { path = \"path/to/deps/lissome/src_gleam\" }\n```\n\n3. Register a hook with the name `LissomeHook` in your `LiveSocket` instance using the `createLissomeHook` function from Lissome. This function takes an object containing the Gleam modules you want to render as an argument. The keys must be the name of the modules, in lowercase, and the values the functions responsables to start the Lustre app in each of those modules (this is typically the `main` function).\n\n```javascript\n// app.js\nimport { createLissomeHook } from \"path/to/deps/lissome/assets/lissome.mjs\"\nimport { main as hello_main } from \"path/to/my_gleam_project/build/dev/javascript/my_gleam_app/hello.mjs\"\nimport { main as about_main } from \"path/to/my_gleam_project/build/dev/javascript/my_gleam_app/pages/about.mjs\"\n\nconst lustreModules = { hello: hello_main, about: about_main }\n\nlet liveSocket = new LiveSocket(\"/live\", Socket, {\n  ...,\n  hooks: { ..., LissomeHook: createLissomeHook(lustreModules) },\n});\n```\n\n4. Add the following watcher to your list of watchers in the `config/dev.exs` file and pass it the option `watch: true` to enable live reloading inside your Gleam project during development:\n\n```elixir\n# config/dev.exs\n\nconfig :my_app, MyAppWeb.Endpoint,\n  ...,\n  watchers: [\n    ...,\n    gleam: {Lissome.GleamBuilder, :build_gleam, [:javascript, [watch: true]]}\n]\n```\n\n5. Update your esbuild config to use the `es2020` target:\n\n```elixir\n# config.exs\n\nconfig :esbuild,\n  ...,\n  my_app: [\n    args:\n      ~w(js/app.js --bundle --target=es2020 --outdir=../priv/static/assets --external:/fonts/* --external:/images/*),\n    ...\n  ]\n```\n\n6. If you plan to use Tailwind CSS inside your Gleam code, add your gleam files to the content key in the Tailwind CSS config.\n\n```javascript\n// tailwind.config.js\n\nmodule.exports = {\n  content: [\n    ...,\n    \"../path/to/my_gleam_app/src/**/*.gleam\",\n  ],\n}\n```","ref":"readme.html#setup"},{"type":"extras","title":"Usage - Lissome","doc":"To render a Lustre app, define a Gleam module with a public function that initializes the app using either the `lustre.simple` or `lustre.application` constructor.\n\n```gleam\n//// src/hello.gleam\n\npub fn init() {\n  //...\n}\n\npub fn update(msg, model) {\n  //...\n}\n\npub fn view(model) {\n  //...\n}\n\npub fn main() {\n  let app = lustre.simple(init, update, view)\n  let assert Ok(_) = lustre.start(app, \"#app\", Nil)\n\n  Nil\n}\n```\n\nNow, inside `HEEX` we can render it using the `.lustre` component:\n\n```elixir\ndefmodule MyAppWeb.MyLiveView do\n  use MyAppWeb, :live_view\n\n  import Lissome.Component\n\n  def mount(_params, _session, socket) do\n    {:ok, socket}\n  end\n\n  def render(assigns) do\n    ~H\"\"\"\n     \n       Content rendered with Phoenix Live View \n       \n        <.lustre id=\"app\" name={:hello} />\n       \n     \n    \"\"\"\n  end\nend\n```\n\nLissome will encode the flags passed from the server as a json object in a script tag with the id `ls-model`. We can retrieve the flags from Gleam using the `lissome.get_flags` helper:\n\n```gleam\nimport lissome // <- remember to add this to your project as a path dependency\n\npub fn main() {\n  let decoder = {\n    use count <- decode.field(\"count\", decode.int)\n    use light_on <- decode.field(\"light_on\", decode.bool)\n    decode.success(Model(count, light_on))\n  }\n\n  let flags = case lissome.get_flags(id: \"ls-model\", using: decoder) {\n    Ok(flags) -> flags\n    Error(_) -> Model(8, True)\n  }\n}\n```\n\nThe id of the script tag could be customized by passing to the `id` attribute in the `.lustre` component the value you want.\n\nCheck out the project in the `example` directory for a complete code example.","ref":"readme.html#usage"},{"type":"extras","title":"SSR - Lissome","doc":"Thanks to the ability of Gleam to compile to both Erlang and JavaScript, we can do server-side rendering of Lustre without having to install Node.js. We only need to make sure we compile the Gleam project to Erlang too. For that, install Lustre in your Elixir project and add the `:gleam` compiler to your list fo compilers:\n\n```elixir\n# mix.exs\ndef project do\n  [\n    compilers: Mix.compilers() ++ [:gleam]\n  ]\nend\n```\n\nthen update your watcher in `config/dev.exs` to include the `:erlang` target:\n\n```elixir\nconfig :my_app, MyAppWeb.Endpoint,\n  ...,\n  watchers: [\n    ...,\n    gleam: {Lissome.GleamBuilder, :build_gleam, [[:javascript, :erlang], [watch: true]]}\n]\n```\n\nand if the name of your gleam project is different than `\"lustre_app\"`, register it in the `gleam_app` config:\n\n```elixir\nconfig :lissome, :gleam_app, \"my_gleam_app\"\n```\n\nNow, pass the `ssr={true}` attribute to each `.lustre` component you want to render in the server.\n\nKeep in mind that `Lissome` will call the `init` and the `view` functions of your Gleam module in order to render the initial HTML. By default `Lissome` will look for functions with that name in your module. If you happen to named them differently, you can pass to the `init_fn` attribute the name of your function responsible for initializing the model and to the `view_fn` attribute the name of your function responsible for rendering the view. Both functions must be public.\n\nThe type your flags has must be public too. Lissome will use this type to construct the appropriate Erlang record. By default, the expected name for that type is `Model`. If you have a different name, pass to the `flags_type` attribute the name of your type in lowercase.\n\n```elixir\n<.lustre\n  id=\"app\"\n  ssr={true}\n  name={:hello}\n  init_fn={:my_init_function}\n  view_fn={:my_view_function}\n  flags_type={:my_flags_type}\n  flags={...}\n/>\n```\n\nRemember to add to your `mix.exs` file any other dependencies your Gleam project needs apart from Lustre and the Gleam standard library. You can add Gleam dependencies to Mix like any other dependency, but with the `app: false` and `manager: :rebar3` options.","ref":"readme.html#ssr"},{"type":"extras","title":"Communicating with Phoenix LiveView - Lissome","doc":"`Lissome` includes helpers for communicating with a LiveView running in the server from Gleam code, using [Lustre's effects for managed side effects](https://hexdocs.pm/lustre/guide/03-side-effects.html). To enable this bidirectional communication, you need to construct your app with `lissome.application`. This is a wrapper around `lustre.application` that allows your `init` and `update` function to receive the LiveView hook instance as an argument. This instance could be used to communicate with the server by passing it to the functions in the `lissome/live_view` module.\n\n```gleam\n// other imports\nimport lissome\nimport lissome/live_view\n\ntype Model {\n  Model(name: String, email: String)\n}\n\ntype Msg {\n  ServerUpdatedName(String)\n  UserUpdatedEmail(String)\n  ServerReply(live_view.LiveViewPushResponse)\n}\n\npub fn init(flags, lv_hook: lissome.LiveViewHook) {\n  let eff = live_view.handle_event(\n    lv_hook: lv_hook,\n    event: \"send-name\",\n    on_reply: ServerUpdatedName\n  )\n\n  #(flags, eff)\n}\n\npub fn update(model, msg, lv_hook: lissome.LiveViewHook) {\n  case msg {\n    ServerUpdatedName(name) -> #(Model(..model, name:), effect.none())\n    UserUpdatedEmail(email) -> {\n      let eff = live_view.push_event(\n        lv_hook: lv_hook,\n        event: \"update-email\",\n        payload: email,\n        on_reply: ServerReply\n      )\n\n      #(Model(..model, email:), eff)\n    }\n    ServerReply(live_view.LiveViewPushResponse(_reply, _ref)) -> #(\n      model,\n      effect.none(),\n    )\n  }\n}\n\npub fn view(model) {\n  //...\n}\n\npub fn main(hook: lissome.LiveViewHook) {\n  let flags = Model(\"John\", \"jhon@gmail.com\")\n  let app = lissome.application(init, update, view, hook)\n  let assert Ok(_) = lustre.start(app, \"#app\", flags)\n\n  Nil\n}\n```\n\nNote that the `hook` instance is passed to your entry function as its only argument. This is done by Lissome when rendering the module.","ref":"readme.html#communicating-with-phoenix-liveview"},{"type":"extras","title":"Working with Gleam types - Lissome","doc":"When doing SSR, Lissome needs to initialize your app's model by passing the flags as arguments. Since Gleam types are compiled to Erlang tuples, there is a challenge when passing non-primitive types as flags from Elixir because Erlang tuples are not easy serializable to JSON.\n\nTo address this, Lissome provides the `Lissome.GleamType` module. This module defines a struct that represent a Gleam type. During SSR, Lissome automatically detects these structs in the flags and converts them to the correct Erlang terms. This conversion happens recursively for any nested `Lissome.GleamType` structs. The `Lissome.GleamType` struct can also be serialized to JSON.\n\nGleam compiles types constructors that do not have specific fields, like `Ok(a)`, `Error(a)` or `Some(a)`, to a tuple, where the first value is the name of the type constructor as an atom and the second one the value. To represent that kind of types, we can use the `Lissome.GleamType.from_value/2` function:\n\n```elixir\n<.lustre\n  module={:hello}\n  ssr={true}\n  flags={%{name: Lissome.GleamType.from_value(:some, \"Jhon\")}}\n>\n```\n\nWhen a type has multiple fields, Gleam compiles it to an [Erlang record](https://www.erlang.org/doc/system/ref_man_records.html). An Erlang record is a tuple where the first element is the name of the type constructor as an atom and the rest elements are the values. Erlang expects the values are in a specific order and includes that information in a `.hrl` file. To represent those types we can use the `Lissome.GleamType.from_record/4` function:\n\n```elixir\n<.lustre\n  module={:hello}\n  ssr={true}\n  flags={%{person: Lissome.GleamType.from_record(\n    :person,\n    :hello,\n    %{name: \"Jhon\", age: 30}\n  )}}\n>\n```\n\nThe first argument is the name of the type constructor in lowercase, the second one is the name of the module where that type is defined and the third one is a map with all the values we want to pass to the type constructor.\n\nWhen the `Lissome.GleamType` struct is encoded to JSON, we get:\n\n- The raw value when the type is not compiled to an Erlang record.\n- A map with all types fields and its values when the type is compiled to an Erlang record.\n\nSee the `Lissome.GleamType` module in the documentation for more details.","ref":"readme.html#working-with-gleam-types"},{"type":"extras","title":"Roadmap - Lissome","doc":"- [x] Improvements to the SSR.\n- [x] Gleam's helpers for communicating with Phoenix LiveView and supporting Lustre's effects.\n- [x] Live reload for Gleam.\n- [x] Helpers to work with Gleam types and their Erlang representation in Elixir.\n- [ ] Support for `lustre.component` constructor.\n- [ ] Support for Lustre's `server components`.\n- [ ] Support for [`LiveJson`](https://github.com/Miserlou/live_json).","ref":"readme.html#roadmap"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.37.1"}}